/*
 *	pe_analy.h
 */

/*	Copyright (C) 1999 Sebastian Biallas (sb@web-factory.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *   published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef pe_analy_h
#define pe_analy_h

#include "analy.h"
#include "htpe.h"


class pe_analyser: public analyser {
public:
	ht_pe_shared_data 	*pe_shared;
	htstream 			*file;
	tarea			*validarea;

					pe_analyser(): analyser() {};
	virtual			~pe_analyser() {};
			void		init(ht_pe_shared_data *Pe_shared, htstream *File);
			int 		load(htstream *f);
	virtual	void		done();

	virtual	ADDR 	branchaddr(OPCODE *opcode);
	virtual	void		*bufptr(ADDR Addr);
	virtual	void		examineopcode(OPCODE *opcode);                 // abstract
	virtual	void 	init_codeanalyser();
	virtual	void 	init_unasm();
	virtual	tbranchtype 	isbranch(OPCODE *opcode);
	virtual	void 	log(char *msg);
	virtual	ADDR		nextvalid(ADDR Addr);
	virtual	bool 	validaddr(ADDR Addr, tsectype action);
};

#endif
