/* 
 *	The HT Editor
 *	htapp.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTAPP_H__
#define __HTAPP_H__

#include "htdialog.h"
#include "htobj.h"

/*
 *	CLASS ht_menu
 */

class ht_menu: public ht_view {
public:
	ht_menu(bounds *b);
	~ht_menu();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
};

/*
 *	CLASS ht_keyline
 */

class ht_keyline: public ht_view {
public:
	ht_keyline(bounds *b);
	~ht_keyline();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
};

/*
 *	CLASS ht_app
 */

class ht_app: public ht_group {
private:
	ht_logviewer *logviewer;
	ht_menu *menu;
	ht_keyline *keyline;

	ht_window *findwindowbynumber(int index);
	int findfreewinnumber();
public:
	ht_app(bounds *b);
	~ht_app();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
		   int load(htstream *f);
	virtual void store(htstream *f);
/* new */
	int new_window(char *filename);
	void delete_window(int index);
	void focus_window(int index);
	int logf(const char *format, ...);

	void popup_window_list();

	void popup_view_list();
	void popup_view_list_dump(ht_view *view, ht_listbox *listbox, ht_collection *structure, int depth, int *currenti, ht_view *currentv);

	void popup_color_list();
};

/*
 * exports
 */

extern void backref();

extern ht_app *app;
extern screendrawbuf *screen;

#define LOG(a...) app->logf(a);

/*
 *	INIT
 */

int init_app();

/*
 *	DONE
 */

void done_app();

#endif /* __HTAPP_H__ */
