/* 
 *	The HT Editor
 *	htcfg.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htcfg.h"
#include "htdebug.h"
#include "htstream.h"

cfg_objects *cfg_objs;

#ifdef DJGPP
//#define default_config_file "c:\\ht.cfg"
#define default_config_file ".\\ht.cfg"
#else
#define default_config_file "~/.htconfig"
#endif

#define ht_config_magic MAGICD("HTCF")

/* current version */
#define ht_config_fileversion      ht_config_fileversion1
#define ht_config_header			ht_config_header1

/*** all config_headers ***/

/* VERSION 1 (for ht-0.3.992 and later) */
#define ht_config_fileversion1	1
struct ht_config_header1 {
	dword magic;
	dword fileversion;
};
/**/

int save_config()
{
	htstream *f=new htrawstream(default_config_file, "wb");
	if (f->geterror()) return 0;
/* write config header */
	ht_config_header header;
	header.magic=ht_config_magic;
	header.fileversion=ht_config_fileversion;
	f->write(&header, sizeof header);
/**/
	app->store(f);
	return 1;
}

int load_config()
{
	htstream *f=new htrawstream(default_config_file, "rb");
	if (f->geterror()) return 0;
/* read config header */
	ht_config_header header;
	f->read(&header, sizeof header);
	if (header.magic!=ht_config_magic) return 0;
	if (header.fileversion!=ht_config_fileversion) return 0;
/**/
	app->load(f);
	return 1;
}

/*
 *	CLASS cfg_object
 */

cfg_object::cfg_object(object *_obj, dword _obj_id)
{
	obj=_obj;
	obj_id=_obj_id;
}

cfg_object::~cfg_object()
{
}

/*
 *	CLASS cfg_objects
 */

cfg_objects::cfg_objects()
{
}

cfg_objects::~cfg_objects()
{
}

void cfg_objects::register_obj(object *obj, dword obj_id)
{
	if (find_obj(obj_id)) ERROR("attempt to register object_id twice !");
	cfg_object *o=new cfg_object(obj, obj_id);
	objs->add(o);
}

object *cfg_objects::find_obj(dword obj_id)
{
	int c=objs->count();
	for (int i=0; i<c; i++) {
		cfg_object *o=(cfg_object*)objs->get(i);
		if (o->obj_id==obj_id) return o->obj;
	}
	return 0;
}

