/* 
 *	The HT Editor
 *	htexpl.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htexpl.h"

#include <string.h>

#define MAX_EXPL_COUNT 32

struct expl_s {
	int table_id;
	int_hash *hash;
};

expl_s *expl[MAX_EXPL_COUNT];
int expl_count=0;

int_hash *find_expl(int table_id)
{
	for (int i=0; i<expl_count; i++) {
		if (expl[i]->table_id==table_id) return expl[i]->hash;
	}
	return 0;
}

void register_expl(int table_id, int_hash *hash)
{
	if (!find_expl(table_id)) {
		expl_s *e=new expl_s;
		e->table_id=table_id;
		e->hash=hash;
		expl[expl_count++]=e;
		assert(expl_count<MAX_EXPL_COUNT);
	}
}

int unregister_expl(int table_id)
{
	for (int i=0; i<expl_count; i++) {
		if (expl[i]->table_id==table_id) {
			delete expl[i];
			expl_count--;
			memmove(expl[i], expl[i+1], (expl_count-i)* sizeof expl[i]);
			return 1;
		}
	}
	return 0;
}

