/* 
 *	The HT Editor
 *	htidle.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htdata.h"
#include "htidle.h"

object *idle_objs[10]; // very dynamically
int	idle_obj_count=0;

void register_idle_object(object *o)
{
	for (int i=0; i<idle_obj_count; i++) {
		if (!idle_objs[i]) {
			idle_objs[i] = o;
			return;
		}
	}
	idle_objs[idle_obj_count++] = o;
}

void unregister_idle_object(object *o)
{
	for (int i=0; i<idle_obj_count; i++) if (idle_objs[i]==o) {
		idle_objs[i] = NULL;
	}
}

void do_idle()
{
	for (int i=0; i<idle_obj_count; i++) if (idle_objs[i]) {
		idle_objs[i]->idle();
	}
}


