/* 
 *	The HT Editor
 *	htmzhead.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmzhead.h"
#include "htstring.h"
#include "viewers.h"

char *mzheader[]=
{
	"magic                                            "_WORD("00000000"),
	"bytes on last page of file                       "_WORD("00000002"),
	"pages in file                                    "_WORD("00000004"),
	"number of relocations                            "_WORD("00000006"),
	"size of header in paragraphs                     "_WORD("00000008"),
	"minimum extra paragraphs needed                  "_WORD("0000000a"),
	"maximum extra paragraphs needed                  "_WORD("0000000c"),
	"initial SS value                                 "_WORD("0000000e"),
	"initial SP value                                 "_WORD("00000010"),
	"checksum                                         "_WORD("00000012"),
	"initial IP value                                 "_WORD("00000014"),
	"initial CS value                                 "_WORD("00000016"),
	"offset of relocation table                       "_WORD("00000018"),
	"overlay number                                   "_WORD("0000001a"),
	"reserved                                         "_BYTE("0000001c")" "_BYTE("0000001d")" "_BYTE("0000001e")" "_BYTE("0000001f")" "_BYTE("00000020")" "_BYTE("00000021")" "_BYTE("00000022")" "_BYTE("00000023"),
	"reserved                                         "_BYTE("00000024")" "_BYTE("00000025")" "_BYTE("00000026")" "_BYTE("00000027")" "_BYTE("00000028")" "_BYTE("00000029")" "_BYTE("0000002a")" "_BYTE("0000002b"),
	"reserved                                         "_BYTE("0000002c")" "_BYTE("0000002d")" "_BYTE("0000002e")" "_BYTE("0000002f")" "_BYTE("00000030")" "_BYTE("00000031")" "_BYTE("00000032")" "_BYTE("00000033"),
	"reserved                                         "_BYTE("00000034")" "_BYTE("00000035")" "_BYTE("00000036")" "_BYTE("00000037")" "_BYTE("00000038")" "_BYTE("00000039")" "_BYTE("0000003a")" "_BYTE("0000003b"),
	"file offset of new executable header             "_DWORD("0000003c"),
	0
};

int htmzheader_detect(htstream *file)
{
	return 1;
}

ht_view *htmzheader_init(bounds *b, htstream *file, ht_group *group)
{
	ht_uviewer *v=new ht_uviewer(b, "mz/header", file, htvc_edit);
	hts_mask *m=new hts_mask(file, 0);
	m->add_mask_table(mzheader);
	v->insertsub(m);
	return v;
}

viewer_int htmzheader_int = {
	htmzheader_detect,
	htmzheader_init
};
