/* 
 *	The HT Editor
 *	htpeexp.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTPEEXP_H__
#define __HTPEEXP_H__

#include "htdata.h"
#include "viewers.h"

extern viewer_int htpeexports_int;

/*
 *	CLASS ht_pe_export_viewer
 */

class ht_pe_export_viewer: public ht_uviewer {
public:
	ht_pe_export_viewer(bounds *b, char *desc, htstream *file, int caps);
	~ht_pe_export_viewer();
/* overwritten */
		virtual void ref(dword id);
};

/*
 *	CLASS ht_pe_export_function
 */

class ht_pe_export_function: public ht_data {
public:
	int ordinal;

	int byname;
	char *name;
	int function_address;

	ht_pe_export_function();
	ht_pe_export_function(int function_address, int ordinal);
	ht_pe_export_function(int function_address, int ordinal, char *name);
	~ht_pe_export_function();
};

struct ht_pe_export {
	ht_collection funcs;
};

#endif /* !__HTPEEXP_H__ */
