/*
 *   htkeyb.h - LINUX implementation
 */
 
/*
 * FIXME: keys with negative values are not (yet) usable under Linux...
 */ 

#ifndef __HTKEYB_H__
#define __HTKEYB_H__

#include "config.h"
#include CURSES_HDR
#undef clear
#undef move

int htkeypressed();
int htgetkey();

#define K_Escape		0x1b
#define K_Return		0x0a
#define K_Space		 	0x20
#define K_Delete		KEY_DC
#define K_Insert		-2
#define K_BackSpace		KEY_BACKSPACE

#define HT_META_KEY(c) ((c) | 0x80000000)

#define K_F1                   KEY_F(1)
#define K_F2                   KEY_F(2)
#define K_F3                   KEY_F(3)
#define K_F4                   KEY_F(4)
#define K_F5                   KEY_F(5)
#define K_F6                   KEY_F(6)
#define K_F7                   KEY_F(7)
#define K_F8                   KEY_F(8)
#define K_F9                   KEY_F(9)
#define K_F10                  KEY_F(10)
#define K_F11                  KEY_F(11)
#define K_F12                  KEY_F(12)
#define K_Home                 KEY_HOME
#define K_End                  KEY_END
#define K_Up                   KEY_UP
#define K_Down                 KEY_DOWN
#define K_Left                 KEY_LEFT
#define K_Right                KEY_RIGHT
#define K_PageUp               KEY_PPAGE
#define K_PageDown             KEY_NPAGE
#define K_Control_F5           -4
#define K_Tab		       '\t'
#define K_BackTab	       KEY_BTAB
#define K_Control_Left         -6
#define K_Control_Right        -7
#define K_Control_K            HT_META_KEY('k')
#define K_Control_PageUp       HT_META_KEY(KEY_PPAGE)
#define K_Control_PageDown     HT_META_KEY(KEY_NPAGE)
#define K_Alt_F1	       -8

#define K_Alt_1                HT_META_KEY('1')
#define K_Alt_2                HT_META_KEY('2')
#define K_Alt_3                HT_META_KEY('3')
#define K_Alt_4                HT_META_KEY('4')
#define K_Alt_5                HT_META_KEY('5')
#define K_Alt_6                HT_META_KEY('6')
#define K_Alt_7                HT_META_KEY('7')
#define K_Alt_8                HT_META_KEY('8')
#define K_Alt_9                HT_META_KEY('9')
#define K_Alt_0                HT_META_KEY('0')

#endif /* !__HTKEYB_H__ */
